' Add a reference to the COM library "Microsoft Shell Controls and Automation."
Public Class Form1
    Private Sub btnGo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGo.Click
        Dim name As String = ""
        Dim descr As String = ""
        Dim path As String = ""
        Dim working_dir As String = ""
        Dim args As String = ""

        Dim result As String = _
            GetShortcutInfo(txtShortcut.Text, name, path, descr, working_dir, args)

        If result.Length > 0 Then
            MessageBox.Show(result, "Error", MessageBoxButtons.OK, MessageBoxIcon.Error)
        Else
            txtName.Text = name
            txtDescription.Text = descr
            txtPath.Text = path
            txtWorkingDirectory.Text = working_dir
            txtArguments.Text = args
        End If
    End Sub

    ' Get information about this link.
    ' Return an error message if there's a problem.
    Private Function GetShortcutInfo(ByVal full_name As String, ByRef name As String, ByRef path As String, ByVal descr As String, ByRef working_dir As String, ByRef args As String) As String
        Try
            ' Make a Shell object.
            Dim shl As New Shell32.Shell()

            ' Get the shortcut's folder and name.
            Dim shortcut_path As String = full_name.Substring(0, full_name.LastIndexOf("\"))
            Dim shortcut_name As String = full_name.Substring(full_name.LastIndexOf("\") + 1)
            If Not shortcut_name.EndsWith(".lnk") Then shortcut_name &= ".lnk"

            ' Get the shortcut's folder.
            Dim shortcut_folder As Shell32.Folder = shl.NameSpace(shortcut_path)

            ' Get the shortcut's file.
            Dim folder_item As Shell32.FolderItem = shortcut_folder.Items.Item(shortcut_name)
            If folder_item Is Nothing Then
                Return "Cannot find shortcut file '" & full_name & "'"
            ElseIf Not folder_item.IsLink Then
                ' It's not a link.
                Return "File '" & full_name & "' isn't a shortcut."
            Else
                ' Display the shortcut's information.
                Dim lnk As Shell32.ShellLinkObject = folder_item.GetLink
                name = folder_item.Name
                descr = lnk.Description
                path = lnk.Path
                working_dir = lnk.WorkingDirectory
                args = lnk.Arguments
                Return ""
            End If

        Catch ex As Exception
            Return ex.Message
        End Try
    End Function
End Class
